<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

echo'
<script type="text/javascript">
<!--
topLevel=5 // top z-index
lastID=""
function changeZindex(obj){
id=obj.id
document.getElementById(id).style.zIndex=topLevel

if(lastID==""){
lastID=id
}

if(lastID==id){
document.getElementById(id).style.zIndex=topLevel
}
else{
document.getElementById(lastID).style.zIndex=""
}

lastID=id
}
// -->
</script>
';
	/*
		коллаж изображеий из заданного каталога в uploads
	*/
	
	$par = array();
  $par['source_dir'] = 'header_collage'; // директорий в uploads, где картинки
  $par['width'] = 200; // ширина элемента коллажа
  $par['height'] = 150; // высота эллемента коллажа
  $par['pointx'] = 20; // начальная точка вывода элементов
  $par['pointy'] = 20; // где будут выведены элементы по высоте
  $par['angle'] = array(20,-15,25,10,20,-10,15,25,-15); // углы на которые будут повернуты элементы
  $par['borderx'] = 6; // бордюр рамки за изображением по x
  $par['bordery'] = 8; // бордюр рамки за изображением по y
  $par['stepx'] = 170; // шаг вывода элементов
  $par['count'] = 5; // кол-во эллементов

	
	//коллаж будем производить только один раз после скидывания кеша.
 $cache_key = '';	// чтобы вычисление коллажа происходило только после сброса кеша введите ключ
 //лучше после создания превьюшек закомментровать вызов функции двумя строчками ниже
 if( !$cache_key or !mso_get_cache($cache_key))
 {
	  create_header_collage_images($par);
	  mso_add_cache($cache_key, true);
 }

 $path_url = getinfo('uploads_url') . $par['source_dir'] . '/';
 $path_dir = getinfo('uploads_dir') . $par['source_dir'] . '/';
 $files = get_path_files($path_dir . 'mini-rotate/', $path_url . 'mini-rotate/', false);
 shuffle($files);

echo '<div class="head">';	
echo '<div class="header-picture">';

$i=1;	
foreach ($files as $file)
{
  if($i > $par['count']) break; 
  $pointx = $par['pointx']+($i-1)*$par['stepx'];
  $file_jpg = str_replace( ".png" , ".jpg" , $file);
  echo '<div id= "' . $i . '" onMouseOver="changeZindex(this)" style="position: absolute;	top: ' . $par['pointy'] . 'px; left: ' . $pointx . 'px; z-index:' . $i . '">';	
		echo '<a class="lightbox" href="' . $path_url . $file_jpg . '"><img src="' . $path_url . 'mini-rotate/' . $file . '" title="Увеличить"/></a>';
  echo '</div>';
$i++;
}


  $stylesheet = getinfo('stylesheet_url');

	echo '<div class="right text-right w25 social">';
	
		echo '<a class="header-social rss" href="' . getinfo('rss_url') . '"><img src="' . $stylesheet . 'images/social/rss.png" alt="RSS" title="RSS"></a>';
		
		if ($u = mso_get_option('default_twitter_url', 'templates', ''))
			echo '<a class="header-social twitter" rel="nofollow" href="' . $u .'"><img src="' . $stylesheet . 'images/social/twitter.png" alt="Twitter" title="Twitter"></a>';
		
		if ($u = mso_get_option('default_facebook_url', 'templates', ''))
			echo '<a class="header-social facebook" rel="nofollow" href="' . $u .'"><img src="' . $stylesheet . 'images/social/facebook.png" alt="Facebook" title="Facebook"></a>';
			
		if ($u = mso_get_option('default_skype_url', 'templates', ''))
			echo '<a class="header-social skype" rel="nofollow" href="' . $u .'"><img src="' . $stylesheet . 'images/social/skype.png" alt="Skype" title="Skype"></a>';
			
		if ($u = mso_get_option('default_vkontakte_url', 'templates', ''))
			echo '<a class="header-social vkontakte" rel="nofollow" href="' . $u .'"><img src="' . $stylesheet . 'images/social/vkontakte.png" alt="В контакте" title="В контакте"></a>';
		
		if ($u = mso_get_option('default_jabber_url', 'templates', ''))
			echo '<a class="header-social jabber" rel="nofollow" href="' . $u .'"><img src="' . $stylesheet . 'images/social/jabber.png" alt="Jabber" title="Jabber"></a>';
		
		if ($u = mso_get_option('default_gplus_url', 'templates', ''))
			echo '<a class="header-social gplus" rel="nofollow" href="' . $u .'"><img src="' . $stylesheet . 'images/social/gplus.png" alt="Google plus" title="Google plus"></a>';	
	
	echo '</div>';
	


	echo '<div class="left text-left w25 social">';
	
		echo '<a class="header-social home" href="' . getinfo('site_url') . '"><img src="' . $stylesheet . 'images/home.png" alt="Главная" title="Главная"></a>';
		
			echo '<a class="header-social sitemap" rel="nofollow" href="' . getinfo('site_url') . 'sitemap"><img src="' . $stylesheet . 'images/sitemap.png" alt="Карта сайта" title="Карта сайта"></a>';
		
			echo '<a class="header-social contact" rel="nofollow" href="' . getinfo('site_url') . 'comments"><img src="' . $stylesheet . 'images/contact.png" alt="Связяться с автором сайта" title="Связяться с автором сайта"></a>';
			
			echo '<a class="header-social comments" rel="nofollow" href="' . getinfo('site_url') . 'contact"><img src="' . $stylesheet . 'images/all-comments.png" alt="Комментарии на сайте" title="Комментарии на сайте"></a>';

		
	
	echo '</div>';
	
	echo '<div class="clearfix"></div>';
	
	echo '</div>';
	
echo '</div>';




function rotate_img_collage($ramka , $img , $angle , $width , $height , $borderx , $bordery)
{
   $res = imagecreatetruecolor($width,$height);
   $trans = imagecolorat($res,0,0);
 
   imagecopyresized ($res,$ramka,
                  0,0,
                  0,0,
                  $width,$height,
                  imagesx($ramka),imagesy($ramka));
                  
  $trans = imagecolorat($res,0,0);
  imagecolortransparent($res,$trans);
  
 $trans = imagecolorat($res,0,0);
 imagecopyresized ($res,$img,
                  $borderx,$bordery,
                  0,0,
                  $width-2*$borderx,$height-2*$bordery,
                  imagesx($img),imagesy($img));
  
  $res = imagerotate($res, $angle ,-1);
  imagealphablending($res, true); 
  imagesavealpha($res, true);                  
   
  return $res;                
}



	
// создаим изображения для коллажа
function create_header_collage_images($par=array())
{
    if (!isset($par['source_dir'])) $par['source_dir'] = 'header_collage';
    if (!isset($par['width'])) $par['width'] = 150;
    if (!isset($par['height'])) $par['height'] = 113;
    if (!isset($par['pointx'])) $par['pointx'] = 40;
    if (!isset($par['pointy'])) $par['pointy'] = 30;
    if (!isset($par['angle'])) $par['angle'] = array(20,-15,25,10,20,-10,15,25,-15);;
    if (!isset($par['borderx'])) $par['borderx'] = 6;
    if (!isset($par['bordery'])) $par['bordery'] = 8;
    if (!isset($par['stepx'])) $par['stepx'] = 150;
    if (!isset($par['count'])) $par['count'] = 5;
    if (!isset($par['img_array'])) $par['img_array'] = false;

	  $header = getinfo('uploads_dir') . $par['source_dir'] . '/header.jpg';
	  $ramka = getinfo('uploads_dir') . $par['source_dir'] . '/ramka.png';
	  $result =  getinfo('uploads_dir') . $par['source_dir'] . '/result.jpg';

    $path = getinfo('uploads_dir') . $par['source_dir'] . '/';

    if (!$par['img_array']) //если картинки не переданы
		{
		   $CI = & get_instance(); // подключение CodeIgniter
		   $CI->load->helper('directory'); // хелпер для работы с каталогами
		   $files = directory_map($path, true); // получаем все файлы в каталоге
	   	 $exts = array('jpg', 'jpeg');
		   foreach ($files as $file)
		   {
			    if (@is_dir($path . $file)) continue; // это каталог
			    $ext = substr(strrchr($file, '.'), 1);// расширение файла
				  if (strpos($file, '_') === 0) continue; // исключаем файлы, начинающиеся с _
			    // расширение подходит?
			    if (in_array($ext, $exts))
			    {
				      if ( in_array($file , array('header.jpg' , 'ramka.png' , 'result.jpg')) ) continue; // исключаем вспомогательные файлы
				      $par['img_array'][] = $file;
			    }
		   }
    }
	  extract($par); 
	  
    $ramka = imagecreatefrompng($ramka); 
    $i=0;
	  foreach ($img_array as $key=>$image)
	  {
	     $full_path = $path . $image;
	     $img = imagecreatefromjpeg($full_path);
	     if (!isset($angle[$i])) $i=0;
	     $cur_angle = $angle[$i];
       $res = rotate_img_collage($ramka , $img , $angle[$i] , $width , $height , $borderx , $bordery);	
       $image = str_replace(".jpg" , ".png" , $image);
       imagepng($res, $path . 'mini-rotate/' . $image); 
       $i++;
    }	  
    
}
# end file